/**
 * Created on 16-ott-2002
 */
package it.uniba.di.dme.gui.interfaces;

import java.awt.event.ActionEvent;

import javax.swing.event.ListSelectionEvent;


/**
 * Common interface for graphic components that need an action listener (and just one).
 *
 * @author Ignazio Palmisano 
 */
public interface ComponentWithActionListener {
	/**
	 * the behaviour make a choice on what to do,  based on the source and the type of the action
	 * @param e the event fired by a component
	 */
	public void switchActionPerformed(ActionEvent e);

	/**
	 * the behaviour make a choice on what to do,  based on the source and the type of the action (list selection)
	 * @param e the event fired by a component
	 */
	public void switchSelectionPerformed(ListSelectionEvent e);
}
