package it.uniba.di.dme.userinfo.gui;



import it.uniba.di.dme.utility.GUIMisc;
import it.uniba.di.dme.utility.InternalsStringContainer;
import it.uniba.di.dme.utility.UserInfoStringContainer;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;


/**
 * @author $author$
 * @version $Revision$
 */
public class UserInfoAgentGUI extends JFrame {
	private JPanel panelInit;
	private PanelInterest panelInterest;
	private PanelComandi panelComandi;
	private PanelQuestion panelQuestion;
	private PanelBody panelBody;
	private PanelPrivacy panelPrivacy;
	private Object myUser;
	private PanelPersonality panelPersonality;

	// pannello cartelle
	private JTabbedPane Cartelle = new JTabbedPane();
	private JPanel miniPanel = new JPanel(new GridLayout(1, 1, 5, 5));
	public JButton OKButton = new JButton(InternalsStringContainer.Ok);
	public JButton exitButton = new JButton(InternalsStringContainer.Exit);

	// Constructor
	public UserInfoAgentGUI(ActionListener theListener, Object user) {
		super();
		myUser = user;
		OKButton.addActionListener(theListener);
		exitButton.addActionListener(theListener);

		panelPersonality = new PanelPersonality();
		panelInit = new JPanel(new BorderLayout(5, 5));
		panelQuestion = new PanelQuestion();
		panelInterest = new PanelInterest();
		panelComandi = new PanelComandi();
		panelBody = new PanelBody();
		panelPrivacy = new PanelPrivacy();

		try {
			jbInit();
		} catch (Exception e) {
			e.printStackTrace(System.out);
		}
	}

	/**
	 * shows the gui
	 */
	public void showGUI() {
		this.setVisible(true);
	}

	/**
	 * loads new data
	 *
	 * @param newData the user data
	 */
	public void loadData(Object newData) {
		panelComandi.txtName.setText("foo");
		panelComandi.txtSurname.setText("foo");

		if (true) {
			panelComandi.cbSexM.setSelected(true);
		} else {
			panelComandi.cbSexF.setSelected(true);
		}

		panelComandi.txtBorn.setText("otherFoo");
		panelComandi.txtEmail.setText("otherFoo");
		panelComandi.txtTelephone.setText("");
		panelComandi.txtWork.setText("otherFoo");
	}

	/**
	 * 
	 */
	void RiempiUser() {
		RiempiIdentity();
		RiempiUserIdentify();
		RiempiBody();
		RiempiBrain();
		RiempiPersonality();
	}

	/**
	 * 
	 */
	void RiempiIdentity() {
	}

	/**
	 * 
	 */
	void RiempiUserIdentify() {
	}

	/**
	 * 
	 */
	void RiempiBody() {
	}

	/**
	 * 
	 */
	void RiempiPersonality() {
	}

	/**
	 * 
	 */
	void RiempiBrain() {
		RiempiIntMusic();
		RiempiIntSport();
		RiempiIntFun();
		RiempiIntCinema();
	}

	/**
	 * 
	 */
	void RiempiIntMusic() {
	}

	/**
	 * 
	 */
	void RiempiIntSport() {
	}

	/**
	 * 
	 */
	void RiempiIntFun() {
	}

	/**
	 * 
	 */
	void RiempiIntCinema() {
	}

	/**
	 * init of the component
	 *
	 * @throws Exception if there is any problem intiating the component
	 */
	void jbInit() throws Exception {
		Cartelle.add(panelComandi, UserInfoStringContainer.Information);
		Cartelle.add(panelInterest, UserInfoStringContainer.Interest);
		Cartelle.add(panelQuestion, "Details");
		Cartelle.add(panelPrivacy, UserInfoStringContainer.Privacy);
		Cartelle.add(panelPersonality, UserInfoStringContainer.Personality);
		Cartelle.add(panelBody, UserInfoStringContainer.Body);
		Cartelle.setPreferredSize(new Dimension(330, 380));
		panelInit.add(Cartelle);
		miniPanel.add(OKButton);
		miniPanel.add(exitButton);
		panelInit.add(miniPanel, BorderLayout.SOUTH);

		this.setTitle(UserInfoStringContainer.UserInfo);
		this.getContentPane().add(panelInit);

		GUIMisc.setFont(new java.awt.Font(InternalsStringContainer.sansserif,
				0, 10), this.getComponents());
		this.pack();
	}

	/**
	 * @return
	 */
	public Object getUser() {
		//updating data
		RiempiUser();

		return myUser;
	}
}
