package it.uniba.di.dme.utility;

import java.awt.Component;
import java.awt.Container;
import java.awt.Font;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.border.Border;
import javax.swing.border.EmptyBorder;
import javax.swing.border.LineBorder;


/**
 * This class is a repository for predefined values used in the interface
 *
 * @author Antonio Giuliani 
 */
public class GUIMisc {
	public final static Insets spacing = new Insets(5, 5, 5, 5);
	public final static Border emptyspace = new EmptyBorder(spacing);
	public final static Border contorno = BorderFactory.createCompoundBorder(emptyspace,
			BorderFactory.createCompoundBorder(
				LineBorder.createBlackLineBorder(), emptyspace));

	/**
	 * @param theString name of the image
	 *
	 * @return the image
	 */
	public static ImageIcon getImageIcon(String theString) {
		return new ImageIcon(GUIMisc.class.getResource(theString));
	}

	/**
	 * sets the font for a list of components, and their subcomponents
	 * @param theFont the font to set
	 * @param thearray the array of components*/
	public static void setFont(Font theFont, Object[] thearray) {
		for (int i = 0; i < thearray.length; i++) {
			if (thearray[i] instanceof Component) {
				((Component) thearray[i]).setFont(theFont);
			}

			if (thearray[i] instanceof Container) {
				setFont(theFont, ((Container) thearray[i]).getComponents());
			}
		}
	}
}
