/*
 * Created on 27-ott-2003
 */
package slides;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Stack;

/**
 * Questa classe contiene codice di esempio per l'utilizzo di liste, pile, mappe, iteratori.
 * E' intenzionalmente scritta in modo non ottimale (in particolare, scarsa dal punto di vista progettuale)
 * Come esercizio, riscrivere il metodo main creando i metodi opportuni 
 * Questo che state leggendo  un commento javadoc...
 * @author Ignazio Palmisano
 * */
public class SimpleProgram {
	/** lista che pu essere usata nella classe*/
	private List list;
	/** mappa che pu essere usata nella classe*/
	private Map map;
	/** pila che pu essere usata nella classe*/
	private Stack stack;
	/** set che pu essere usato nella classe*/
	private Set set;
	
	/**costruttore di default*/
	public SimpleProgram(){
	}
	
	/**metodo statico;  obbligatorio che la nostra applicazione abbia almeno un metodo main ( il primo che viene eseguito)*/
	public static void main(String[] args){
		// la variabile che permette di far riferimento ai  metodi non statici di questa classe
		SimpleProgram simpleProgram= new SimpleProgram();
		
		// un contatore che servir spesso... :-)
		int i;
		// inizializzo la lista con una ArrayList
		simpleProgram.setList(new ArrayList());
		
		// aggiungo tutti gli elementi di args alla lista
		List l=simpleProgram.getList();
		for(i=0; i<args.length; i++){
			l.add(i, args[i]);
		}
		
		// aggiungo altri elementi...
		l.add("nuovo elemento 1");
		l.add("nuovo elemento 2");
		l.add("nuovo elemento 3");
		l.add("nuovo elemento 4");
		
		// stampo la lista
		Iterator it=l.iterator();
		while(it.hasNext()){
			System.out.println(it.next().toString());
		}
		
		System.out.println("*********************************");
		
		// lavoriamo con la mappa, ora
		simpleProgram.setMap(new HashMap());
		Map m= simpleProgram.getMap();
		// inserisco tutti gli oggetti di l in m, utilizzando Integer creati a partire dalla posizione per indicizzare gli elementi
		for(i=0; i<l.size(); i++){
			m.put(new Integer(i), l.get(i));
		}
		
		// stampo il contenuto della mappa
		it=m.entrySet().iterator();
		while(it.hasNext()){
			System.out.println(it.next().toString());
		}

		System.out.println("*********************************");
		
		// e per finire con la pila
		simpleProgram.setStack(new Stack());
		Stack s=simpleProgram.getStack();
		// inserisco nello stack gli elementi della lista
		for(i=0; i<l.size(); i++){
			s.push(l.get(i));
		}
		
		// stampo lo stack
		it=s.iterator();
		while(it.hasNext()){
			System.out.println(it.next().toString());
		}

		System.out.println("*********************************");

		// ora un gioco di prestigio: rimozione dei duplicati
		simpleProgram.setSet(new HashSet());
		Set set=simpleProgram.getSet();
		
		// inserisco tutti gli elementi nel set
		set.addAll(l);
		
		// stampo gli elementi, avendo cura di rimuovere i duplicati...
		it=set.iterator();
		while(it.hasNext()){
			System.out.println(it.next().toString());
		}
		System.out.println("*********************************");

		// notato la procedura per la rimozione delle entry duplicate?
		System.out.println("\n\n***********\nThat's all folks!\n***********");

	} 

	/**
	 * Javadoc per metodi:
	 * primo passo: descrizione del metodo
	 * Ritorna un riferimento alla lista
	 * Secondo passo: descrizione degli argomenti, dei tipi ritornati ed eventualmente delle eccezioni 
	 * @return la lista
	 */
	public List getList() {
		return this.list;
	}

	/**
	 * modifica il valore della lista (la sostituisce con un'altra lista, la vecchia lista va persa)
	 * @param list il nuovo oggetto lista
	 */
	public void setList(List l) {
		this.list = l;
	}

	/**
	 * per esercizio al lettore attento...
	 * @return
	 */
	public Map getMap() {
		return this.map;
	}

	/**
	 * @param map
	 */
	public void setMap(Map m) {
		this.map = m;
	}

	/**
	 * @return
	 */
	public Stack getStack() {
		return this.stack;
	}

	/**
	 * @param stack
	 */
	public void setStack(Stack s) {
		this.stack = s;
	}

	/**
	 * @return
	 */
	public Set getSet() {
		return this.set;
	}

	/**
	 * @param set
	 */
	public void setSet(Set s) {
		this.set = s;
	}

}
